# MPI_T_init_thread

Initialize the MPI_T execution environment

## Synopsis

    int MPI_T_init_thread(int required, int *provided)

## Input Parameters

required
  desired level of thread support (integer)

## Output Parameters

provided
  provided level of thread support (integer)

## Notes

## The valid values for the level of thread support are

MPI_THREAD_SINGLE
  Only one thread will execute.
MPI_THREAD_FUNNELED
  The process may be multi-threaded, but only the main thread will make MPI_T calls (all MPI_T calls are funneled to the main thread).
MPI_THREAD_SERIALIZED
  The process may be multi-threaded, and multiple threads may make MPI_T calls, but only one at a time: MPI_T calls are not made concurrently from two distinct threads (all MPI_T calls are serialized).
MPI_THREAD_MULTIPLE
  Multiple threads may call MPI_T, with no restrictions.

## Thread and Interrupt Safety

This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as `malloc` or other non-MPICH runtime routines that are themselves not interrupt-safe.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarantee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.

## See Also

MPI_T_finalize